> For the complete documentation index, see [llms.txt](https://docs.fractalworks.io/joule/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fractalworks.io/joule/use-case-examples/banking/aggregates-and-user-defined-time-based-window-functions.md).

# Aggregates and user defined time based window functions

***

This example computes basic aggregates and a mix of stateless and stateful analytic functions or time base sliding windows.

## Use case configuration

*File: app-aggregatesAndEMA.env*

```bash
SOURCEFILE=conf/sources/stockQuoteStream.yaml
ENGINEFILE=conf/usecases/slidingEventWindowAnalyticsAggregatesAndEMA.yaml
PUBLISHFILE=conf/publishers/fileStandardAnalytics.yaml
```

## Pipeline configuration <a href="#processor-configuration" id="processor-configuration"></a>

This pipeline configures a sliding window of 2.5 second with a 500ms slide which computes aggregates and three window listener functions, all using the same event window.

{% code overflow="wrap" %}

```yaml
processing unit:
  pipeline:
    - filter:
        expression: "symbol == 'CVCO'"
    - time window:
        emitting type: slidingQuoteAnalytics
        aggregate functions:
          SUM: [ volume ]
          MEAN: [ volatility ]
        window listeners:
          - exponential moving average:
              attributes: [ ask, bid ]
              parameters:
                emaFactor: 0.33333
          - minmax normalization:
              attributes: [ ask, bid ]
          - zscore normalization:
              attributes: [ ask, bid ]
        policy:
          type: slidingTime
          slide: 500
          window size: 2500

emit:
  select: "symbol, ask_EMA, bid_EMA, volume_SUM, volatility_MEAN, ask_MINMAX_NORM, bid_MINMAX_NORM, ask_ZSCORE, bid_ZSCORE"

group by:
  - symbol
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fractalworks.io/joule/use-case-examples/banking/aggregates-and-user-defined-time-based-window-functions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
